 <template>
  <div id="app">
    <main>
      <fixed-header>
        <div :class="homePage ? 'home-page navbar' : 'navbar'" >
          <div class="main-navbar">
            <nav class="container navbar navbar-expand-lg navbar-light" id="nav">
              

              <div class="navbar-nav navbar-inline shop-nav">
                <ul>
                  <li>
                    <router-link to="/" class="mob-nav mob-home"></router-link>
                    <router-link to="/products" class="mob-nav mob-shop"></router-link>
                  </li>
                </ul>

                <ul class="d-flex">
                  <li class="nav-item cart-wrapper">
                    <router-link to="/cart" class="nav-link">
                      <span class="cart-icon"></span>
                      
                      <span class="ml-1 cart-items-n">{{this.cartProducts.length}}</span>
                    </router-link>

                    <transition name="fade">
                      <div class="cart-pop-up" v-if="showPopUp">
                        <span></span> Товар добавлен в корзину!
                      </div>
                    </transition>
                  </li>
                  <li class="nav-item dropdown" v-if="loggedIn">
                    <a
                      class="nav-link dropdown-toggle login-btn"
                      href="#"
                      id="navbarDropdownMenuLink"
                      role="button"
                      data-toggle="dropdown"
                      aria-haspopup="true"
                      aria-expanded="false"
                    >{{this.loggedUser.firstName.toUpperCase()}} <span class="toggle-icon"></span></a>
                    <div class="dropdown-menu profile-dropdown" v-if="loggedIn" aria-labelledby="navbarDropdownMenuLink">
                      <router-link to="/profile" class="dropdown-item">
                        <span>КАБИНЕТ</span>
                      </router-link>
                      <router-link
                        to="/"
                        class="dropdown-item text-danger"
                        @click.native="loc_logout"
                      ><span>ВЫЙТИ</span></router-link>
                    </div>
                  </li>
                  <li class="nav-item" v-if="!loggedIn">
                    <router-link to="/login" class="nav-link login-btn">ВОЙТИ</router-link>
                  </li>
                </ul>
              </div>
              <div class="collapse navbar-collapse" id="navbarText">
                <ul class="navbar-nav mr-auto ml-30">
                  <li class="nav-item main-menu-item active">
                    <router-link to="/" class="nav-link">ДОМАШНЯЯ</router-link>
                  </li>
                  <li class="nav-item main-menu-item">
                    <router-link to="/products" class="nav-link">ПОСТУПЛЕНИЯ</router-link>
                  </li>

                  <li class="nav-item main-menu-item">
                    <router-link to="/about" class="nav-link">О НАС</router-link>
                  </li>

                  <li class="nav-item main-menu-item" v-if="loggedUser && loggedUser.isAdmin">
                    <router-link to="/admin" class="nav-link">ADMIN</router-link>
                  </li>
                </ul>
                <ul class="navbar-nav navbar-column ml-auto">
                  
                  <li class="nav-item">
                    <router-link to="/cart" class="nav-link">
                      <span class="cart-icon"></span>
                      
                      <span class="ml-1 cart-items-n">{{this.cartProducts.length}}</span>
                    </router-link>

                    <transition name="fade">
                      <div class="cart-pop-up" v-if="showPopUp">
                        <span></span> Товар добавлен в корзину!
                      </div>
                    </transition>
                  </li>
                  <li class="nav-item dropdown" v-if="loggedIn">
                    <a
                      class="nav-link dropdown-toggle"
                      href="#"
                      id="navbarDropdownMenuLink"
                      role="button"
                      data-toggle="dropdown"
                      aria-haspopup="true"
                      aria-expanded="false"
                    >{{this.loggedUser.firstName.toUpperCase()}} <span class="toggle-icon"></span></a>
                    <div class="dropdown-menu profile-dropdown" v-if="loggedIn" aria-labelledby="navbarDropdownMenuLink">
                      <router-link to="/profile" class="dropdown-item">
                        <span>КАБИНЕТ</span>
                      </router-link>
                      <router-link
                        to="/"
                        class="dropdown-item text-danger"
                        @click.native="loc_logout"
                      ><span>ВЫЙТИ</span></router-link>
                    </div>
                  </li>
                  <li class="nav-item" v-if="!loggedIn">
                    <router-link to="/login" class="nav-link login-btn">ВОЙТИ</router-link>
                  </li>
                </ul>
              </div>
            </nav>
          </div>
        </div>
      </fixed-header>
      
      <contact></contact>

      <transition name="fade">
        <router-view :key="$route.fullPath" @addToCart="addToCart"/>
      </transition>
    </main>

    <div class="container-fluid instagram-block">
      <ul class="instagram-carousel">
        <li><a href="#"><img src="./assets/ftr-insta-1.jpg" alt="Instagram" /></a></li>
        <li><a href="#"><img src="./assets/ftr-insta-2.jpg" alt="Instagram" /></a></li>
        <li><a href="#"><img src="./assets/ftr-insta-3.jpg" alt="Instagram" /></a></li>
        <li><a href="#"><img src="./assets/ftr-insta-4.jpg" alt="Instagram" /></a></li>
        <li><a href="#"><img src="./assets/ftr-insta-5.jpg" alt="Instagram" /></a></li>
        <li><a href="#"><img src="./assets/ftr-insta-6.jpg" alt="Instagram" /></a></li>
      </ul>
    </div><!-- Instagram /- -->
    <footer class="container-fluid no-left-padding no-right-padding footer-main">
      <!-- Container -->
      <div class="container">
        <ul class="ftr-social">
          <li><a href="#" title="Facebook"><i class="fa fa-facebook"></i><span> Facebook</span></a></li>
          <li><a href="#" title="Instagram"><i class="fa fa-instagram"></i><span> Instagram</span></a></li>
          <li><a href="#" title="Youtube"><i class="fa fa-youtube"></i><span> YouTube</span></a></li>
        </ul>
        <div class="copyright">
          <p>Copyright @ 2019</p>
        </div>
      </div><!-- Container /- -->
    </footer><!-- Footer Main /- --> 
  </div>
</template>

<script>
import { mapState, mapActions, mapMutations } from "vuex";
import {
  getLoggedInUser
} from "./components/shared/service/authService";
import FixedHeader from 'vue-fixed-header';
import Contact from "@/components/shared/Contact-Popup";
export default {
  data() {
    return {
      loggedIn: false, showPopUp: false,
      cartValue: 0, homePage: false
    };
  },
  computed: mapState(["cartProducts", "loggedUser"]),
  methods: {
    ...mapMutations(["SET_CART_PRODUCTS", "ADD_LOGGED_USER"]),

    getLocalProducts() {
      const products = JSON.parse(localStorage.getItem("iki-cart"));

      if (products) {
        this.SET_CART_PRODUCTS(products);
      }
    },

    loc_logout() {
      localStorage.removeItem("_auth");
      this.$http.get(`${process.env.VUE_APP_BASE_URL}/logout`);
      this.$router.push("/");
      location.reload();
    },
    addToCart() {
      let self = this;
      self.showPopUp = true;
      setTimeout(function() {
        self.showPopUp = false;
      }, 3000);
    }
  },
  components: {
    FixedHeader, Contact
  },
  watch: {
    '$route.path': function(nVal) {
      if (nVal === '/' || nVal === '/products') {
        this.homePage = true;
      } else {
        this.homePage = false;
      }
      const loggedUser = getLoggedInUser();
      if (loggedUser) {
        this.loggedIn = true;
        this.ADD_LOGGED_USER(loggedUser);
      }
    }
  },
  created() {
    this.getLocalProducts();
    if (this.$route.name === 'home') this.homePage = true;
    const loggedUser = getLoggedInUser();
    this.cartProductsLength = this.$store.getters.cartProducts.length;
    if (loggedUser) {
      this.loggedIn = true;
      this.ADD_LOGGED_USER(loggedUser);
    }

    this.$nextTick(() => {
      if( $(".instagram-carousel").length ) {
        $(".instagram-carousel").owlCarousel({
          loop: true,
          margin: 0,
          nav: false,
          dots: false,
          autoplay: true,
          responsive:{
            0:{
              items: 2
            },
            480:{
              items: 3
            },
            575:{
              items: 4
            },
            768:{
              items: 5
            },
            992:{
              items: 6
            }
          }
        });
      }
    });
  }
};
</script>


<style lang="scss">
@import "../node_modules/bootstrap/dist/css/bootstrap.min.css";

#nav {
  padding: 15px;
  font-size: 14px;

  .main-menu-item a {
    font-weight: bold;
    color: #2c3e50;
    &.router-link-exact-active {
      color: $maincolor;
    }
  }
}

@media (max-width: 992px) {
  #nav {
    position: fixed;
    background-color: #fff;
    z-index: 9999;
    .navbar-inline .dropdown-menu {
      top: 55px;
      background-color: #fff;
    }
  }
}

html {
  position: relative;
  min-height: 100%;
}

* {
 font-family: 'Maven Pro', sans-serif;
}
ul {
  padding: 0;
  margin: 0;
  list-style-type: none;
}

.checked {
  background-image: url('./assets/checked.svg');
  height: 15px;
  width: 15px;
  line-height: 20px;
  display: inline-block;
}

button:disabled {
  background: #dddddd;
  &:hover {
    background: #dddddd;
  }
}

.home-component {
  background-color: #fbfbfb;
}

.error-msg {
  color: #9c1212;
}

.m-dropdown {
  position: relative;
}
.m-dropdown-menu {
  border: 1px solid lightgray;
  position: absolute;
  top: 98%;
  background-color: #fff;
  width: 100%;
  z-index: 9999;
  li {
    cursor: pointer;
    padding: 5px;
    &:hover {
      background-color:#f5f5f5; 
    }
  }
}

.buttonGreen-outline {
  width: 100%;
  color: #41b883;
  background-color: transparent;
  border-color: #41b883;
}
.buttonGreen-outline:hover {
  color: #ffffff;
  background-color: #41b883;
  border-color: #41b883;
}

.button-default {
  padding: .25rem .5rem;
  font-size: .875rem;
  line-height: 1.5;
  border-radius: .2rem;
  font-weight: bold;
  border: 1px solid transparent;
  cursor: pointer;
  margin-bottom: 0;
  &:hover {
    color: lightgray;
  }
}

.success-button {
  background-color: $maincolor;
  color: #fff;
  padding: .25rem .5rem;
  font-size: .875rem;
  line-height: 1.5;
  border-radius: .2rem;
  font-weight: bold;
  border: 1px solid transparent;
  &:hover {
    background-color: #75d8ab;
  }
}

.buttonGreen:hover {
  background-color: #42a97b;
}

.profile-dropdown {
  width: 110px;
  height: 80px;
  min-width: auto;
  border-radius: unset;
  border: none;
  left: -20px;
  font-size: 14px;
  padding-right: 20px;
  padding-bottom: 0;
  border: 1px solid #f9f9f9;
  border-top: unset;
  top: 35px;
  margin-top: 1px;
  a {
    padding: 5px 20px;
    &:hover {
      text-decoration: underline;
      background-color: unset;
    }
  }

}
.main-menu-item a {
  border-bottom: 2px solid transparent;
}
.main-menu-item:hover {
  a {
    border-bottom: 2px solid $maincolor;
  }
}
.main-input {
  height: 21px;
  border: 0;
  width: calc(100% - 2px);
  margin-left:1px;
  background-color: unset;
  box-shadow: -7px 10px 0px -7px #d6d6d6, 7px 10px 0px -7px #d6d6d6;
  -webkit-transition: box-shadow 0.3s;
  transition: box-shadow 0.3s;
}

.main-input.invalid {
  box-shadow: -7px 10px 0px -7px red, 7px 10px 0px -7px red;
}
.main-input:focus {
  outline: none;
  box-shadow: -7px 10px 0px -7px $maincolor, 7px 10px 0px -7px $maincolor;
}

@media (max-width: 768px) {
  .main-input {
    height: 25px;

    box-shadow: unset;
    border-radius: unset;
    border-bottom: 2px solid lightgray;

    &:focus {
      box-shadow: unset;
      border-color: $maincolor;
    }

    &.invalid {
      box-shadow: unset;
      border-color: red;
    }
  }
}

.action-button {
  border: none;
  box-shadow: 0 0 0 0 transparent;
  cursor: pointer;
  display: block;
  font-size: 16px;
  font-weight: 500;
  line-height: 1;
  text-align: center;
  width: 100%;
  padding: 15px;
  margin-top: 20px;
  transition: background 0.4s ease-in-out;
  border: 1px solid transparent;

  &.black-button {
    background: #393c4a;
    color: #ffffff;

    &:hover {
      background: #415060;
    }

    &:disabled {
      background: lightgray;
    }
  }

  &.gray-button {
    background: #d5d5d5;
    color: #000;
    border: 1px solid #d5d5d5;

    &:hover {
      background: #b1afaf;
    }
  }

  &.main-button {
    background: #ede8d7;
    font-weight: normal;
    &:hover {
      background: transparent;
      color: #000;
      border: 1px solid lightgray;
    }
    &:disabled {
      background: transparent;
      color: gray;
      border: 1px solid lightgray;
    }
  }

  &.delete-button {
    font-weight: normal;
    color: #ef6e6e;
    border: 1px solid #f1a9a9;
    &:hover {
      border: 1px solid red;
      color: red;
    }
    &:disabled {
      border: 1px solid red;
      color: red;
    }
  }
}

.ok-button {
  max-width: 50px;
  margin-top: 0;
  padding: 7px;
  font-weight: normal;
  border-radius: unset;
}

.panel-break {
  text-align: center;
  font-size: 16px;
  color: gray;
  padding: 20px;
  padding-bottom: 10px;
  position: relative;
  text-transform: uppercase;
}
.panel-break::before {
    background-color: $maincolor;
    bottom: 0;
    content: "";
    height: 2px;
    left: 0;
    margin: 0 auto;
    position: absolute;
    right: 0;
    width: 30px;
}
.instagram-block {
  padding-left: 0;
  padding-right: 0;

  .instagram-carousel {
    direction: ltr;
  }
  .instagram-block {
    ul {
      padding-left: 0;
      padding-right: 0;
      margin-bottom: 0;
    }
  }
  .owl-controls {
    margin: 0 !important;
  }
}
footer {
  background-color: #ede8d7;
  .ftr-social {
    margin-bottom: 0;
    padding: 0;
    padding-top: 20px;
    text-align: center; 

    li {
      display: inline-block;
      margin: 0 33px;
      a {
        color: #000;
      }
    }
  }
  .copyright {
      padding-top: 29px;
      padding-bottom: 10px;
      text-align: center;
      position: relative;
      font-size: 14px;
  }
}

.spinner {
  width: 70px;
  text-align: center;
  display: inline-block;
}

.spinner > div {
  width: 8px;
  height: 8px;
  background-color: $maincolor;
  margin-right: 3px;
  border-radius: 100%;
  display: inline-block;
  -webkit-animation: sk-bouncedelay 1.4s infinite ease-in-out both;
  animation: sk-bouncedelay 1.4s infinite ease-in-out both;
}

.spinner .bounce1 {
  -webkit-animation-delay: -0.32s;
  animation-delay: -0.32s;
}

.spinner .bounce2 {
  -webkit-animation-delay: -0.16s;
  animation-delay: -0.16s;
}

.errorMessage {
  padding: 10px;
  background-color: #f7e5e1;
}

@-webkit-keyframes sk-bouncedelay {
  0%, 80%, 100% { -webkit-transform: scale(0) }
  40% { -webkit-transform: scale(1.0) }
}

@keyframes sk-bouncedelay {
  0%, 80%, 100% { 
    -webkit-transform: scale(0);
    transform: scale(0);
  } 40% { 
    -webkit-transform: scale(1.0);
    transform: scale(1.0);
  }
}
.navbar {
  padding: 0;
  z-index: 9999;
}

.vue-fixed-header {
  .main-navbar {
    width: 100%;
    position: absolute;
    left: 0;
    right: 0;
    top: 0;
    bottom: 0;
    min-height: 72px;
    background: #ffffff7a;
    border-bottom: 1px solid #f9f9f9;
  }

  @media (max-width: 992px) {
    .main-navbar {
      width: 100%;
      position: static;
    }
  }

}
.mob-nav {
  display: inline-block;
  height: 30px;
  width: 30px;
  background-size: cover;
  margin-right: 10px;
  margin-top: 5px;
}
.mob-home {
  background-image: url('./assets/home.svg');

  &.router-link-exact-active {
    background-image: url('./assets/home-1.svg');
  }
}
.mob-shop {
  background-image: url('./assets/casual-t-shirt-.svg');

  &.router-link-exact-active {
    background-image: url('./assets/casual-t-shirt-1.svg');
  }
}

.home-page.vue-fixed-header .dropdown-menu {
  background: #ffffff7a;
}

.navbar.vue-fixed-header--isFixed {
  position: fixed;
  left: 0;
  top: 0;
  width: 100vw;
  height: 72px;
  background-color: #fff;

  .main-navbar {
    background-color: #fff
  }

  .dropdown-menu {
    background: #fff;
  }
}

.nav-item {
  position: relative;
  letter-spacing: 1.2px;
  .cart-pop-up {
    position: absolute;
    width: 220px;
    padding: 10px 20px;
    background: #fff;
    box-shadow: 0 5px 10px 0 rgba(0,0,0,.2);
    border: 1px solid lightgray;
    left: -81px;

    span {
      height: 15px;
      width: 15px;
      display: inline-block;
      background-image: url('./assets/checked.svg');
    }
  }
}
.nav-item .dropdown-toggle:after {
  content: none;
}
.nav-item .toggle-icon {
  background-image: url('./assets/down-chevron.svg');
  display: inline-block;
  height: 10px;
  width: 10px;
}

.cart-icon {
  background-image: url('./assets/shopping-bag.svg');
  display: inline-block;
  background-size: cover;
  height: 15px;
  width: 15px;
}
.cart-items-n {
  font-size: 16px;
}

.navbar-inline {
  display: none;
}

@media (max-width: 992px) {
  .navbar-inline {
    display: flex;
    flex-direction: row;
    justify-content: space-between;
    width: 100%;
    .nav-item {
      margin-right: 10px;
    }

    .dropdown-menu {
      position: absolute;
    }
  }
  .navbar-column {
    display: none;
  }
}

.navbar-column .dropdown-menu {
  top: 55px;
}

.navbar-inline .dropdown-menu {
  top: 36px;
  border: 1px solid #f3f3f3;
}

.collapsed + .navbar-inline .dropdown-menu {
  top: 56px;
  border: 1px solid #f3f3f3;
}

.app-table {
  th {
    border-top: unset;
    border-bottom: 1px solid lightgray !important;
    font-size: 16px;
    font-weight: normal;
  }
  td {
    font-size: 14px;
  }
}

.modal-dialog {
  margin-top: 10%;
  .modal-content {
    border-radius: unset;
  }
}

@media (max-width: 768px) {
  .modal-dialog {
    margin-top: 30%;
  }
}

.fade-enter-active, .fade-leave-active {
  transition: opacity .2s;
}
.fade-enter, .fade-leave-to {
  opacity: 0;
}

.single-line-input {
  display: flex; 
  li {
    margin-right: 10px;
  }
}

.phone-code {
  font-size: 16px;
  line-height: 30px;
  color: #000;
}

.pagination {
  text-align: center;
  margin-top: 30px;
  display: inline-block;
  width: 100%;

  .nav-links {
    display: inline-block;

    & > .page-numbers {
      background-color: #fff;
      border-radius: 0;
      border: none;
      border-left: 1px solid #ebebeb;
      border-right: 1px solid #ebebeb;
      color: #464646;
      font-size: 12px;
      font-weight: bold;
      float: left;
      margin: 0;
      padding: 5px 14px;
      text-transform: uppercase;
      text-decoration: none;
      -webkit-transition: all 1s ease 0s;
      -moz-transition: all 1s ease 0s;
      -o-transition: all 1s ease 0s;
      transition: all 1s ease 0s;

      &.current, &:focus, &:hover {
          background-color: #ebebeb;
          border-color: transparent;
          color: #464646;
      }
    }
  }
}

.sale-sticker {
  position: absolute;
  background: #000;
  color: #fff;
  z-index: 10;
  top: 0;
  left: 0;
  width: 36px;
  height: 70px;
  font-size: 15px;
  font-weight: 500;
  font-style: normal;
  font-stretch: normal;
  line-height: normal;
  letter-spacing: 3px;

  span {
    transform: rotate(-90deg);
    position: relative;
    display: block;
    font-size: 15px;
    top: 42%;
    text-transform: uppercase;
  }
}

.old-price {
  position: relative;
  display: inline-block;
}
.old-price::before {
  content: '';
  border-bottom: 1px solid gray;
  width: 100%;
  position: absolute;
  right: 0;
  top: 50%;
}
.discount-price {
  color: red;
}
.logo {
  text-align: center;
  padding-top: 15px;
}

.login-btn {
  margin-top: 2px;
}
</style>
